old_int21:
		.dd		0

int21:
		pushf
		cmp		ah,0x71
		je		?lfn_functions
		add		sp,2
		jmpf	[cs:old_int21]
?lfn_functions:
		popw	[cs:lfn_stack+4]
		mov		[cs:old_stk.offs],sp
		mov		[cs:old_stk.seg],ss
		mov		ss,[cs:lfn_seg]
		mov		sp,lfn_stack
		pushad
		push	ds
		push	es
		sti								; could be here a while
		cld								; so all functions can assume dir is up
		mov		bp,sp					; bp is saved by the pushad
		and		esp,0xffff				; ensure esp is 16 bits for addressing
;		call	dump_regs
		pushw	?leave_isr				; push the return address to emulate CALLcc
		andb	[bp+sf.FLAGS],~1		; clear carry
		cmp		al,0x0d
		jel		lfn_reset_drive			;
		cmp		al,0x39
		jel		lfn_make_dir			; 
		cmp		al,0x3a
		jel		lfn_remove_dir			; 
		cmp		al,0x3b
		jel		lfn_change_dir			; 
		cmp		al,0x41
		jel		lfn_delete_file			; 
		cmp		al,0x43
		jel		lfn_extended_attrs		; 
		cmp		al,0x47
		jel		lfn_get_current_dir		; 
		cmp		al,0x4e
		jel		lfn_find_first			; 
		cmp		al,0x4f
		jel		lfn_find_next			; 
		cmp		al,0x56
		jel		lfn_rename_file			;
		cmp		al,0x60
		jel		lfn_truename			; 
		cmp		al,0x6c
		jel		lfn_open_file			; 
		cmp		al,0xa0
		jel		lfn_volume_info			;
		cmp		al,0xa1
		jel		lfn_find_close			; 
		cmp		al,0xa2
		jel		?invalid_function		; 
		cmp		al,0xa3
		je		?invalid_function		; 
		cmp		al,0xa4
		je		?invalid_function		; 
		cmp		al,0xa5
		je		?invalid_function		; 
		cmp		al,0xa6
		jel	    lfn_get_file_info		;
		cmp		al,0xa7
		jel		lfn_time_convert		;
		cmp		al,0xa8
		jel		lfn_generate_short_name	;
		cmp		al,0xa9
		je		?invalid_function		; 
		cmp		al,0xaa
		je		?invalid_function		; 
;		jmp		?invalid_function
?invalid_function:
		movw	[bp+sf.AX],1
		orb		[bp+sf.FLAGS],1
		ret
?leave_isr:
;		call	dump_regs
		pop		es
		pop		ds
		popad
		nop								; 386 bug
		lss		sp,[cs:old_stk]
		push	bp
		mov		bp,sp
		pushw	[cs:lfn_stack+4]
		popw	[bp+6]
		pop		bp
		iret

; define our own stack.
		.align	2
		.dd 64 .dup 0xdeadbeef			; 256 byte stack
lfn_stack = .
		.dw 3 .dup 0					; fake iret frame
lfn_seg:
		.dw		0
old_stk	.struct FARPTR

dump_regs:
		pusha
		push	es
		push	ds
		mov		ax,cs
		mov		es,ax
		mov		ds,ax
		mov		ax,[bp+sf.AX]
		mov		di,_ax
		call	itoh
		mov		ax,[bp+sf.CX]
		mov		di,_cx
		call	itoh
		mov		ax,[bp+sf.DX]
		mov		di,_dx
		call	itoh
		mov		ax,[bp+sf.BX]
		mov		di,_bx
		call	itoh
		mov		ax,[bp+sf.SI]
		mov		di,_si
		call	itoh
		mov		ax,[bp+sf.DI]
		mov		di,_di
		call	itoh
		mov		ax,[bp+sf.DS]
		mov		di,_ds
		call	itoh
		mov		ax,[bp+sf.ES]
		mov		di,_es
		call	itoh
		mov		ax,[bp+sf.FLAGS]
		mov		di,_fl
		call	itoh
		mov		dx,regs_msg
		mov		cx,regs_msg_len
		call	write_message
		pop		ds
		pop		es
		popa
		nop
		ret

itoh:
		push	ax
		mov		al,ah
		call	?h1
		pop		ax
	?h1:
		push	ax
		shr		al,4
		call	?h2
		pop		ax
	?h2:
		and		al,0x0f
		aam
		add		al,ah
		aad		0x10
		add		al,'0'
		mov		[di],al
		inc		di
		ret

regs_msg:
		.db		"ax="
_ax:
		.db		"???? cx="
_cx:
		.db		"???? dx="
_dx:
		.db		"???? bx="
_bx:
		.db		"???? si="
_si:
		.db		"???? di="
_di:
		.db		"???? ds="
_ds:
		.db		"???? es="
_es:
		.db		"???? fl="
_fl:
		.db		"????\r\n"
regs_msg_len = . - regs_msg
